﻿Imports System.ComponentModel

Public Class clsRecurrence
    Implements INotifyPropertyChanged

    Private mintScheduleID As Integer
    Private mdtStartDate As Date
    Private mdtEndDate As Date
    Private mdtmRunTime As TimeSpan
    Private mintRecurrenceType As Integer
    Private mintInterval As Integer
    Private mdtmStartingTime As TimeSpan
    Private mdtmEndingTime As TimeSpan
    Private mintDayOfMonth As Integer
    Private mblnSunday As Boolean
    Private mblnMonday As Boolean
    Private mblnTuesday As Boolean
    Private mblnWednesday As Boolean
    Private mblnThursday As Boolean
    Private mblnFriday As Boolean
    Private mblnSaturday As Boolean
    'Private mintDay As Integer
    Private mintMonthOfYear As Integer
    Private mintInstance As Integer

    Private propertyChangedDelegate As PropertyChangedEventHandler

    Public Sub New(ByVal intScheduleID As Integer, ByVal dtStartDate As Date, ByVal dtEndDate As Date, ByVal dtmRunTime As TimeSpan,
                   ByVal intRecurrenceType As Integer, ByVal intInterval As Integer, ByVal dtmStartingTime As TimeSpan, ByVal dtmEndingTime As TimeSpan,
                   ByVal intDayOfMonth As Integer, ByVal blnSunday As Boolean, ByVal blnMonday As Boolean, ByVal blnTuesday As Boolean,
                   ByVal blnWednesday As Boolean, ByVal blnThursday As Boolean, ByVal blnFriday As Boolean, ByVal blnSaturday As Boolean,
                   ByVal intMonthOfYear As Integer, ByVal intInstance As Integer)

        mintScheduleID = intScheduleID
        mdtStartDate = dtStartDate
        mdtEndDate = dtEndDate
        mdtmRunTime = dtmRunTime
        mintRecurrenceType = intRecurrenceType
        mintInterval = intInterval
        mdtmStartingTime = dtmStartingTime
        mdtmEndingTime = dtmEndingTime
        mintDayOfMonth = intDayOfMonth
        mblnSunday = blnSunday
        mblnMonday = blnMonday
        mblnTuesday = blnTuesday
        mblnWednesday = blnWednesday
        mblnThursday = blnThursday
        mblnFriday = blnFriday
        mblnSaturday = blnSaturday
        'mintDay = intDay
        mintMonthOfYear = intMonthOfYear
        mintInstance = intInstance
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Public Property ScheduleID As Integer
        Get
            Return mintScheduleID
        End Get
        Set(value As Integer)

            mintScheduleID = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("ScheduleID"))
        End Set
    End Property

    Public Property RecurrenceType As Integer
        Get
            Return mintRecurrenceType
        End Get
        Set(value As Integer)

            mintRecurrenceType = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("RecurrenceType"))
        End Set
    End Property

    Public Property StartDate As Date
        Get
            Return mdtStartDate
        End Get
        Set(value As Date)

            mdtStartDate = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("StartDate"))
        End Set
    End Property

    Public Property EndDate As Date
        Get
            Return mdtEndDate
        End Get
        Set(value As Date)

            mdtEndDate = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("EndDate"))
        End Set
    End Property

    Public Property RunTime As TimeSpan
        Get
            Return mdtmRunTime
        End Get
        Set(value As TimeSpan)

            mdtmRunTime = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("RunTime"))
        End Set
    End Property

    Public Property Interval As Integer
        Get
            Return mintInterval
        End Get
        Set(value As Integer)

            mintInterval = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Interval"))
        End Set
    End Property

    Public Property StartingTime As TimeSpan
        Get
            Return mdtmStartingTime
        End Get
        Set(value As TimeSpan)

            mdtmStartingTime = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("StartingTime"))
        End Set
    End Property

    Public Property EndingTime As TimeSpan
        Get
            Return mdtmEndingTime
        End Get
        Set(value As TimeSpan)

            mdtmEndingTime = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("EndingTime"))
        End Set
    End Property

    Public Property DayOfMonth As Integer
        Get
            Return mintDayOfMonth
        End Get
        Set(value As Integer)

            mintDayOfMonth = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("DayOfMonth"))
        End Set
    End Property

    'Public Property Day As Integer
    '    Get
    '        Return mintDay
    '    End Get
    '    Set(value As Integer)

    '        mintDay = value

    '        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Day"))
    '    End Set
    'End Property

    Public Property MonthOfYear As Integer
        Get
            Return mintMonthOfYear
        End Get
        Set(value As Integer)

            mintMonthOfYear = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("MonthOfYear"))
        End Set
    End Property

    Public Property Instance As Integer
        Get
            Return mintInstance
        End Get
        Set(value As Integer)

            mintInstance = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Instance"))
        End Set
    End Property

    Public Property Sunday As Boolean
        Get
            Return mblnSunday
        End Get
        Set(value As Boolean)

            mblnSunday = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Sunday"))
        End Set
    End Property

    Public Property Monday As Boolean
        Get
            Return mblnMonday
        End Get
        Set(value As Boolean)

            mblnMonday = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Monday"))
        End Set
    End Property

    Public Property Tuesday As Boolean
        Get
            Return mblnTuesday
        End Get
        Set(value As Boolean)

            mblnTuesday = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Tuesday"))
        End Set
    End Property

    Public Property Wednesday As Boolean
        Get
            Return mblnWednesday
        End Get
        Set(value As Boolean)

            mblnWednesday = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Wednesday"))
        End Set
    End Property

    Public Property Thursday As Boolean
        Get
            Return mblnThursday
        End Get
        Set(value As Boolean)

            mblnThursday = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Thursday"))
        End Set
    End Property

    Public Property Friday As Boolean
        Get
            Return mblnFriday
        End Get
        Set(value As Boolean)

            mblnFriday = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Friday"))
        End Set
    End Property

    Public Property Saturday As Boolean
        Get
            Return mblnSaturday
        End Get
        Set(value As Boolean)

            mblnSaturday = value

            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Saturday"))
        End Set
    End Property
End Class
