﻿Imports Infragistics.Win.UltraWinEditors
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Private mvlRecurrenceType As ValueList

    Private Enum RecurrenceType
        ''' <summary>
        ''' The One Time
        ''' </summary>
        OneTime = 0
        ''' <summary>
        ''' The Minutes
        ''' </summary>
        Minutes = 1
        ''' <summary>
        ''' The Hourly
        ''' </summary>
        Hourly = 2
        ''' <summary>
        ''' The daily
        ''' </summary>
        Daily = 3
        ''' <summary>
        ''' The weekly
        ''' </summary>
        Weekly = 4
        ''' <summary>
        ''' The monthly
        ''' </summary>
        Monthly = 5
        ''' <summary>
        ''' The N-th day of the month
        ''' </summary>
        MonthNth = 6
        ''' <summary>
        ''' The yearly
        ''' </summary>
        Yearly = 7
        ''' <summary>
        ''' The N-th day of the month of the year
        ''' </summary>
        YearNth = 8

    End Enum

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load


        Dim vliPattern As ValueListItem
        mvlRecurrenceType = New ValueList
        vliPattern = Nothing
        For Each i In [Enum].GetValues(GetType(RecurrenceType))
            If i.Equals(RecurrenceType.MonthNth) = False AndAlso i.Equals(RecurrenceType.YearNth) = False Then
                vliPattern = mvlRecurrenceType.ValueListItems.Add(i)
                If vliPattern.DataValue = RecurrenceType.OneTime Then
                    vliPattern.DisplayText = "One time"
                End If
            End If
        Next

        CreateDataset()

    End Sub

    Private Sub CreateDataset()

        Dim dsSchedule As New DataSet
        Dim rowNew As DataRow


        dsSchedule.Tables.Add("bandSettingDetails")
        dsSchedule.Tables("bandSettingDetails").Columns.Add("ScheduleID", GetType(Integer))
        dsSchedule.Tables("bandSettingDetails").Columns.Add("RecurrenceType", GetType(Integer))
        dsSchedule.Tables("bandSettingDetails").Columns.Add("StartDate", GetType(DateTime))
        dsSchedule.Tables("bandSettingDetails").Columns.Add("EndDate", GetType(DateTime))
        dsSchedule.Tables("bandSettingDetails").Columns.Add("RunTime", GetType(DateTime))

        rowNew = dsSchedule.Tables("bandSettingDetails").NewRow
        rowNew("ScheduleID") = 1
        rowNew("RecurrenceType") = 4
        rowNew("StartDate") = "6/16/2016"
        rowNew("EndDate") = "6/18/2016"
        rowNew("RunTime") = "08:18:42"
        dsSchedule.Tables("bandSettingDetails").Rows.Add(rowNew)


        dsSchedule.Tables.Add("bandScheduleType")
        dsSchedule.Tables("bandScheduleType").Columns.Add("ScheduleID", GetType(Integer))
        dsSchedule.Tables("bandScheduleType").Columns.Add("StartDate", GetType(DateTime))
        dsSchedule.Tables("bandScheduleType").Columns.Add("EndDate", GetType(DateTime))
        dsSchedule.Tables("bandScheduleType").Columns.Add("RunTime", GetType(DateTime))
        dsSchedule.Tables("bandScheduleType").Columns.Add("RecurrenceType", GetType(Integer))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Interval", GetType(Integer))
        dsSchedule.Tables("bandScheduleType").Columns.Add("StartingTime", GetType(DateTime))
        dsSchedule.Tables("bandScheduleType").Columns.Add("EndingTime", GetType(DateTime))
        dsSchedule.Tables("bandScheduleType").Columns.Add("DayOfMonth", GetType(Integer))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Sunday", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Monday", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Tuesday", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Wednesday", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Thursday", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Friday", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Saturday", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Day", GetType(Integer))
        dsSchedule.Tables("bandScheduleType").Columns.Add("MonthOfYear", GetType(Integer))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Instance", GetType(Integer))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Changed", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("Deleted", GetType(Boolean))
        dsSchedule.Tables("bandScheduleType").Columns.Add("ctlScheduleType", GetType(clsRecurrence))

        rowNew = dsSchedule.Tables("bandScheduleType").NewRow
        rowNew("ScheduleID") = 1
        rowNew("RecurrenceType") = 4
        rowNew("StartDate") = "6/16/2016"
        rowNew("EndDate") = "6/18/2016"
        rowNew("RunTime") = "08:18:42"
        rowNew("Interval") = 2
        rowNew("StartingTime") = "00:00:00"
        rowNew("EndingTime") = "00:00:00"
        rowNew("DayOfMonth") = 0
        rowNew("Sunday") = False
        rowNew("Monday") = True
        rowNew("Tuesday") = True
        rowNew("Wednesday") = False
        rowNew("Thursday") = False
        rowNew("Friday") = False
        rowNew("Saturday") = False
        rowNew("Day") = 0
        rowNew("MonthOfYear") = 0
        rowNew("Instance") = 0
        rowNew("Changed") = False
        rowNew("Deleted") = False
        dsSchedule.Tables("bandScheduleType").Rows.Add(rowNew)


        rowNew = dsSchedule.Tables("bandScheduleType").NewRow
        rowNew("ScheduleID") = 1
        rowNew("RecurrenceType") = 4
        rowNew("StartDate") = "6/16/2016"
        rowNew("EndDate") = "6/18/2016"
        rowNew("RunTime") = "08:18:42"
        rowNew("Interval") = 2
        rowNew("StartingTime") = "00:00:00"
        rowNew("EndingTime") = "00:00:00"
        rowNew("DayOfMonth") = 0
        rowNew("Sunday") = False
        rowNew("Monday") = True
        rowNew("Tuesday") = True
        rowNew("Wednesday") = False
        rowNew("Thursday") = False
        rowNew("Friday") = False
        rowNew("Saturday") = False
        rowNew("Day") = 0
        rowNew("MonthOfYear") = 0
        rowNew("Instance") = 0
        rowNew("Changed") = False
        rowNew("Deleted") = False
        dsSchedule.Tables("bandScheduleType").Rows.Add(rowNew)

        For Each rowScheduleType As DataRow In dsSchedule.Tables("bandScheduleType").Rows

            rowScheduleType("ctlScheduleType") = New clsRecurrence(rowScheduleType("ScheduleID"), rowScheduleType("StartDate"), rowScheduleType("EndDate"),
                                                               CType(CheckNull(rowScheduleType("RunTime"), Nothing), DateTime).TimeOfDay, rowScheduleType("RecurrenceType"), rowScheduleType("Interval"),
                                                                CType(CheckNull(rowScheduleType("StartingTime"), Nothing), DateTime).TimeOfDay, CType(CheckNull(rowScheduleType("EndingTime"), Nothing), DateTime).TimeOfDay,
                                                               rowScheduleType("DayOfMonth"), rowScheduleType("Sunday"), rowScheduleType("Monday"),
                                                               rowScheduleType("Tuesday"), rowScheduleType("Wednesday"), rowScheduleType("Thursday"),
                                                               rowScheduleType("Friday"), rowScheduleType("Saturday"), rowScheduleType("MonthOfYear"), rowScheduleType("Instance"))
        Next


        Dim relScheduleType As New DataRelation("bandScheduleType", dsSchedule.Tables("bandSettingDetails").Columns("ScheduleID"), dsSchedule.Tables("bandScheduleType").Columns("ScheduleID"))

        dsSchedule.Relations.Add(relScheduleType)

        grdScheduledReports.DataSource = dsSchedule
    End Sub



    Public Function CheckNull(ByVal objCheck As Object, ByVal objIfNull As Object) As Object
        Try
            If Not objCheck Is Nothing Then
                If IsDBNull(objCheck) = True Then
                    Return objIfNull
                Else
                    Return objCheck
                End If
            Else
                Return objIfNull
            End If
        Catch ex As Exception
            Return Nothing
        End Try
    End Function


    Private Sub grdScheduledReports_InitializeLayout(sender As Object, e As InitializeLayoutEventArgs) Handles grdScheduledReports.InitializeLayout
        e.Layout.AutoFitStyle = AutoFitStyle.ResizeAllColumns
        e.Layout.Override.CellClickAction = UltraWinGrid.CellClickAction.RowSelect
        e.Layout.Override.RowSelectors = DefaultableBoolean.True

        With e.Layout.Bands("bandSettingDetails")

            .Columns("ScheduleID").Hidden = True

            .Columns("StartDate").Header.Caption = "Start Date"
            .Columns("EndDate").Header.Caption = "End Date"
            .Columns("RunTime").Header.Caption = "Run Time"

            .Columns("StartDate").CellClickAction = UltraWinGrid.CellClickAction.Edit
            .Columns("EndDate").CellClickAction = UltraWinGrid.CellClickAction.Edit
            .Columns("RunTime").CellClickAction = UltraWinGrid.CellClickAction.Edit

            .Columns("RecurrenceType").Header.Caption = "Pattern"
            .Columns("RecurrenceType").Style = ColumnStyle.DropDownList
            .Columns("RecurrenceType").CellClickAction = UltraWinGrid.CellClickAction.Edit
            .Columns("RecurrenceType").ButtonDisplayStyle = UltraWinGrid.ButtonDisplayStyle.Always
            .Columns("RecurrenceType").ValueList = mvlRecurrenceType
            .Columns("RecurrenceType").DefaultCellValue = 4

            .Columns("RecurrenceType").Width = 150
            .Columns("RecurrenceType").MinWidth = 150
            .Columns("RecurrenceType").MaxWidth = 150
        End With


        With e.Layout.Bands("bandScheduleType")
            .Override.CellClickAction = CellClickAction.Edit
            .Override.RowSizing = RowSizing.AutoFree
            .ColHeadersVisible = False


            .Columns("ScheduleID").Hidden = True
            .Columns("StartDate").Hidden = True
            .Columns("EndDate").Hidden = True
            .Columns("RunTime").Hidden = True
            .Columns("RecurrenceType").Hidden = True
            .Columns("Interval").Hidden = True
            .Columns("StartingTime").Hidden = True
            .Columns("EndingTime").Hidden = True
            .Columns("DayOfMonth").Hidden = True
            .Columns("Sunday").Hidden = True
            .Columns("Monday").Hidden = True
            .Columns("Tuesday").Hidden = True
            .Columns("Wednesday").Hidden = True
            .Columns("Thursday").Hidden = True
            .Columns("Friday").Hidden = True
            .Columns("Saturday").Hidden = True
            .Columns("Day").Hidden = True
            .Columns("MonthOfYear").Hidden = True
            .Columns("Instance").Hidden = True
            .Columns("Changed").Hidden = True
            .Columns("Deleted").Hidden = True

            .PerformAutoResizeColumns(False, Infragistics.Win.UltraWinGrid.PerformAutoSizeType.AllRowsInBand)
        End With
    End Sub

    Private Sub grdScheduledReports_InitializeRow(sender As Object, e As InitializeRowEventArgs) Handles grdScheduledReports.InitializeRow
        If e.ReInitialize = False Then
            If e.Row.Band.Key = "bandScheduleType" Then

                Dim containerEditorScheduleType As New UltraControlContainerEditor
                containerEditorScheduleType.EnterEditModeMouseBehavior = EnterEditModeMouseBehavior.EnterEditModeAndClick

                Dim ctlRecurrenceWeekly_Edit As New ctlRecurrenceWeekly
                Dim ctlRecurrenceWeekly_Display As New ctlRecurrenceWeekly

                'ctlRecurrenceWeekly_Edit.Dock = DockStyle.Fill
                'ctlRecurrenceWeekly_Display.Dock = DockStyle.Fill

                containerEditorScheduleType.RenderingControl = ctlRecurrenceWeekly_Display
                containerEditorScheduleType.EditingControl = ctlRecurrenceWeekly_Edit
                containerEditorScheduleType.RenderingControlPropertyName = "Recurrence"
                containerEditorScheduleType.EditingControlPropertyName = "Recurrence"

                e.Row.Cells("ctlScheduleType").EditorComponent = containerEditorScheduleType
            End If
        End If
    End Sub

    Private Sub grdScheduledReports_AfterCellUpdate(sender As Object, e As CellEventArgs) Handles grdScheduledReports.AfterCellUpdate
        Debug.WriteLine("AfterCellUpdate - Column:" & e.Cell.Column.Key)
    End Sub

    Private Sub grdScheduledReports_CellChange(sender As Object, e As CellEventArgs) Handles grdScheduledReports.CellChange
        Debug.WriteLine("CellChange - Column:" & e.Cell.Column.Key)
    End Sub
End Class
